<?php

class JobAction extends Action {
	
	public function index() {
					
		//分页
		import('Class.Page', APP_PATH);
		$count = M('job')->count();

		$page = new Page($count, 10);		
		$page->rollPage = 3;
		$page->setConfig('theme','%upPage% %linkPage% %downPage% 共%totalPage%页');
		$limit = $page->firstRow. ',' .$page->listRows;
		$list = M('job')->order('id DESC')->limit($limit)->select();

		$this->page = $page->show();
		$this->vlist = $list;

		$this->title = '招聘信息';
		$this->indexUrl = U('Job/index');//插件首页网址
		$this->display();
	}

	//show
	public function shows() {
					
		$id = I('id', 0, 'intval');
		if ($id <= 0) {
			$this->error('参数错误');
		}

		$content = M('job')->find($id);
		if (!$content) {
			$this->error('记录不存在');
		}

		$this->content = $content;
		$this->title = $content['title']. '-招聘信息';	
		$this->indexUrl = U('Job/index');
		$this->url = U('Job/shows', array('id' => $id));
		$this->tablename = 'job';//use for click update
		$this->id = $id;
		$this->display();
	}


	//添加
	public function apply() {


		$id = I('id', 0, 'intval');
		

		if (IS_POST) {
			
			$data =  I('post.');
			$data['sex'] = intval($data['sex']);	
			$data['birthday'] = str_replace('－', '-', $data['birthday']);	
			/*
			$verify = I('vcode','','md5');
			if (C('cfg_verify_guestbook') == 1 && $_SESSION['verify'] != $verify) {
				$this->error('验证码不正确');
			}
			*/
			if (empty($data['jobtitle'])) {
				$this->error('职位不存在，请重新申请!');
			}
			if (empty($data['personname'])) {
				$this->error('姓名不能为空!');
			}
			if (!isDate($data['birthday'])) {
				$this->error('出生日期不正确，日期格式为1970-1-1');
			} 
			if (strlen($data['tel'])<7) {
				$this->error('手机号码不正确，请重新填写');
			} 
			if (empty($data['content'])) {
				$this->error('自我描述不能为空!');
			}

			
			
			

			$data['publishtime'] = time();
			$data['status'] = 1;
			$uid = get_cookie('uid');//不能用empty(get_cookie('uid')),empty不能用于函数返回值
			$data['userid'] = empty($uid) ? 0 : $uid;
			
		
			$db = M('jobApply');

			if($id = $db->add($data)) {
				$this->success('申请成功',U(GROUP_NAME. '/Job/index'), 10);
			}else {
				$this->error('申请失败，请重新申请');
			}
			exit();
		}

		if ($id <= 0) {
			$this->error('参数错误');
		}

		$jobtitle = M('job')->where(array('id' => $id))->getField('title');
		if (!$jobtitle ) {
			$this->error('记录不存在');
		}

		$this->jobtitle = $jobtitle;
		$this->title = '申请职位';	
		$this->indexUrl = U('Job/index');
		$this->url = U('Job/shows', array('id' => $id));
		$this->display();


		
	}

	

}



?>