<?php
/**
 * Recruitment plugin
 * @copyright 	Copyright (c) 2014-2014 0871k.com All rights reserved.
 * @license 	http://www.0871k.com/helpcms/4.html 
 * @author 		gosea <gosea199@gmail.com> 
*/
class JobAction extends CommonAction {
	
	//列表
	public function index() {		

		$where = array('id' => array('gt', 0));

		//分页
		import('Class.Page', APP_PATH);
		$count = M('job')->where($where)->count();

		$page = new Page($count, 10);		
		$page->rollPage = 7;
		$page->setConfig('theme','%totalRow% %header%  %first% %upPage% %linkPage% %downPage% %end% %nowPage%/%totalPage% 页');
		$limit = $page->firstRow. ',' .$page->listRows;
		$art = M('job')->where($where)->order('id DESC')->limit($limit)->select();

		$this->page = $page->show();
		$this->vlist = $art;
		$this->type = '职位列表';

		$this->display();
	}

	//添加
	public function add() {

		
		//当前控制器名称		
		$actionName = strtolower($this->getActionName());

		if (IS_POST) {
			$this->addPost();
			exit();
		}

		$this->type = '添加招聘信息';
		$this->display();
	}

	//
	public function addPost() {

		$data = I('post.');
		$data['title'] = I('title','' ,'htmlspecialchars,rtrim');
		$data['click'] = 1;
		$data['content'] = I('content', '', '');
		$data['publishtime'] = I('publishtime', time(),'strtotime');
		$data['updatetime'] = time();	
		
		if (empty($data['title'])) {
			$this->error('职位名称不能为空');
		}
	

		if($id = M('job')->add($data)) {

			//内容中的图片
			$img_arr = array();
			$reg = "/<img[^>]*src=\"((.+)\/(.+)\.(jpg|gif|bmp|png))\"/isU";
			preg_match_all($reg, $data['content'], $img_arr, PREG_PATTERN_ORDER);
			// 匹配出来的不重复图片
			$img_arr = array_unique($img_arr[1]);
			if (!empty($img_arr)) {
				$attid = M('attachment')->where(array('filepath' => array('in', $img_arr)))->getField('id', true);
				$dataAtt = array();
				if ($attid) {
					foreach ($attid as $v) {
						$dataAtt[] = array('attid' => $v,'arcid' => $id, 'modelid' => 0, 'desc' => 'job');
					}
					M('attachmentindex')->addAll($dataAtt);
				}
				
			}		

			$this->success('添加成功',U(GROUP_NAME. '/Job/index'));
		}else {
			$this->error('添加失败');
		}
	}

	//编辑
	public function edit() {
	
		$id = I('id', 0, 'intval');
		$actionName = strtolower($this->getActionName());	//当前控制器名称

		if (IS_POST) {
			$this->editPost();
			exit();
		}
		
		$vo = M($actionName)->find($id);
		$vo['content'] = htmlspecialchars($vo['content']);//ueditor
		$this->vo = $vo;				
		$this->type = '修改招聘信息';
		$this->display();
	}


	//修改文章处理
	public function editPost() {


		$data = I('post.');
		$data['title'] = I('title','' ,'htmlspecialchars,rtrim');
		$id = $data['id'] = intval($data['id']);	
		$data['content'] = I('content', '', '');
		$data['publishtime'] = I('publishtime', time(),'strtotime');
		$data['updatetime'] = time();		
		
		if (empty($data['title'])) {
			$this->error('职位名称不能为空');
		}
	
	
		if (false !== M('job')->save($data)) {

			//del
			M('attachmentindex')->where(array('arcid' => $id, 'modelid' => 0, 'desc' => 'job'))->delete();
			//内容中的图片
			$img_arr = array();
			$reg = "/<img[^>]*src=\"((.+)\/(.+)\.(jpg|gif|bmp|png))\"/isU";
			preg_match_all($reg, $data['content'], $img_arr, PREG_PATTERN_ORDER);
			// 匹配出来的不重复图片
			$img_arr = array_unique($img_arr[1]);
			if (!empty($img_arr)) {
				$attid = M('attachment')->where(array('filepath' => array('in', $img_arr)))->getField('id', true);
				$dataAtt = array();
				if ($attid) {
					foreach ($attid as $v) {
						$dataAtt[] = array('attid' => $v,'arcid' => $id, 'modelid' => 0, 'desc' => 'job');
					}
					M('attachmentindex')->addAll($dataAtt);
				}
				
			}

			
			$this->success('修改成功', U(GROUP_NAME. '/Job/index'));
		}else {

			$this->error('修改失败');
		}
		
	}



	//彻底删除
	public function del() {

		$id = I('id',0 , 'intval');
		$batchFlag = I('get.batchFlag', 0, 'intval');
		//批量删除
		if ($batchFlag) {
			$this->delBatch();
			return;
		}

		if (M('job')->delete($id)) {
			M('attachmentindex')->where(array('arcid' => $id, 'modelid' => 0, 'desc' => 'job'))->delete();
			$this->success('彻底删除成功', U(GROUP_NAME. '/Job/index'));
		}else {
			$this->error('彻底删除失败');
		}
	}


	//批量彻底删除
	public function delBatch() {

		$idArr = I('key',0 , 'intval');		
		if (!is_array($idArr)) {
			$this->error('请选择要彻底删除的项');
		}
		$where = array('id' => array('in', $idArr));
	

		if (M('job')->where($where)->delete()) {
			M('attachmentindex')->where(array('arcid' => array('in', $idArr), 'modelid' => 0, 'desc' => 'job'))->delete();
			$this->success('彻底删除成功', U(GROUP_NAME. '/Job/index'));
		}else {
			$this->error('彻底删除失败');
		}
	}

	//简历列表
	public function resume() {		

		$keyword = I('keyword', '', 'htmlspecialchars,rtrim');
		$where = array('id' => array('gt', 0));
		if (!empty($keyword)) {
			$where['personname'] = array('LIKE', "%{$keyword}%");
		}
		

		//分页
		import('Class.Page', APP_PATH);
		$count = M('jobApply')->where($where)->count();

		$page = new Page($count, 10);		
		$page->rollPage = 7;
		$page->setConfig('theme','%totalRow% %header%  %first% %upPage% %linkPage% %downPage% %end% %nowPage%/%totalPage% 页');
		$limit = $page->firstRow. ',' .$page->listRows;
		$art = M('jobApply')->where($where)->order('id DESC')->limit($limit)->select();

		$this->page = $page->show();
		$this->vlist = $art;
		$this->type = '简历列表';
		$this->keyword = $keyword;
		$this->display();
	}


	//编辑
	public function showResume() {
	
		$id = I('id', 0, 'intval');

		if (IS_POST) {
			
			$data = I('post.');
			$data['replaytime'] = time();
			$data['status'] = 3;
			if (false !== M('jobApply')->save($data)) {
				$this->success('处理成功', U(GROUP_NAME. '/Job/resume'));
			}else {
				$this->error('处理失败');
			}

			exit();
		}
		
		$vo = M('jobApply')->find($id);
		if ($vo['status'] == 1) {
			M('jobApply')->where(array('id' => $id))->setField('status', 2);
		}
		
		$this->vo = $vo;				
		$this->type = '查看简历';
		$this->display();
	}

	//彻底删除
	public function delResume() {

		$id = I('id',0 , 'intval');	

		if (M('jobApply')->delete($id)) {
			$this->success('彻底删除成功', U(GROUP_NAME. '/Job/resume'));
		}else {
			$this->error('彻底删除失败');
		}
	}



    public function install(){
        $db_prefix = C('DB_PREFIX');
        $table_name = "{$db_prefix}job";

        if(count(M()->query("SHOW TABLES LIKE '{$table_name}'")) != 0){
            $this->error('job表已经存在，请卸载后再安装');
        }

        $sql=<<<SQL
CREATE TABLE IF NOT EXISTS `{$table_name}` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL DEFAULT '' COMMENT '职位名称',
  `city` varchar(50) NOT NULL DEFAULT '' COMMENT '工作地点',
  `number` int(10) unsigned NOT NULL DEFAULT '1',
  `salary` varchar(20) NOT NULL DEFAULT '' COMMENT '工资待遇',
  `sex` varchar(4) NOT NULL DEFAULT '' COMMENT '性别要求',
  `age` varchar(20) NOT NULL DEFAULT '' COMMENT '年龄要求',
  `education` varchar(10) NOT NULL DEFAULT '' COMMENT '学历要求',
  `experience` varchar(10) NOT NULL DEFAULT '' COMMENT '工作经验',
  `content` text COMMENT '职位描述',
  `publishtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',
  `updatetime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `click` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '点击数',
  `aid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'admin',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
SQL;
        M()->execute($sql);

        $table_name2 = "{$db_prefix}job_apply";
       	$sql=<<<SQL
CREATE TABLE IF NOT EXISTS `{$table_name2}` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `jobtitle` varchar(50) NOT NULL DEFAULT '',
  `personname` varchar(50) NOT NULL DEFAULT '',
  `sex` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `birthday` date NOT NULL DEFAULT '1900-01-01',
  `nation` varchar(20) NOT NULL DEFAULT '' COMMENT '民族',
  `marriage` varchar(10) NOT NULL DEFAULT '' COMMENT '婚否',
  `education` varchar(10) NOT NULL DEFAULT '' COMMENT '学历',
  `experience` varchar(10) NOT NULL DEFAULT '',
  `content` text COMMENT '个人简历',
  `address` varchar(50) NOT NULL DEFAULT '',
  `qq` varchar(15) NOT NULL DEFAULT '',
  `tel` varchar(30) NOT NULL DEFAULT '',
  `email` varchar(50) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `publishtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',
  `replaytime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '处理时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态',
  `userid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
SQL;
        M()->execute($sql);

        if(count(M()->query("SHOW TABLES LIKE '{$table_name}%'")) != 2){
            $this->error('job表未创建成功，请手动检查插件中的sql，修复后重新安装');
        }
        $sort_num = M('menu')->where(array('pid' => 44))->max('sort');
        $sort_num = empty($sort_num) ? 221 : $sort_num+1;
        $data = array(
        		'name' => '招聘管理',
        		'pid'  => 44,
        		'module' => 'Job',
        		'action' => 'index',
        		'parameter' => '',
        		'status' => 1,
        		'sort' => $sort_num,
        	);
        if (!M('menu')->add($data)) {
        	$this->error('添加到menu菜单失败');
        }

        $sort_num = M('node')->where(array('pid' => 1, 'level' => 2))->max('sort');
        $sort_num = empty($sort_num) ? 90 : $sort_num+1;
        
        $data = array(
        		'name' => 'Job',
        		'title' => '招聘管理',
        		'pid'  => 1,
        		'level' => 2,
        		'status' => 1,
        		'sort' => $sort_num,
        	);
        $id = M('node')->add($data);
        if (!$id) {
        	$this->error('添加到node失败');
        }

        $data = array();
        $i = 1;
        $data[] = array('name' => 'index', 'title' => '招聘信息列表', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
        $data[] = array('name' => 'add', 'title' => '添加招聘', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
        $data[] = array('name' => 'edit', 'title' => '编辑招聘', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
        $data[] = array('name' => 'del', 'title' => '删除招聘', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);        
        $data[] = array('name' => 'resume', 'title' => '简历列表', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
        $data[] = array('name' => 'showResume', 'title' => '查看简历', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
        $data[] = array('name' => 'delResume', 'title' => '删除简历', 'pid'  => $id, 'level' => 3, 'status' => 1,'sort' => $i++,);
       
       foreach ($data as $k => $val) {
       		$ret = M('node')->add($val);
       }
       $this->success('安装成功', U('index'));
    }

    public function uninstall(){
        $db_prefix = C('DB_PREFIX');
        $sql = "DROP TABLE IF EXISTS `{$db_prefix}job`;";        
        M()->execute($sql);
        $sql = "DROP TABLE IF EXISTS `{$db_prefix}job_apply`;";        
        M()->execute($sql);
        M('menu')->where(array('name' => '招聘管理'))->delete();
        $id = M('node')->where(array('name' => 'Job', 'pid' => 1))->getField('id');
        if (!empty($id)) {
        	$child_id = M('node')->where(array('pid' => $id))->getField('id',true);
        	$child_id[] = $id;
        	M('node')->where(array('id' => array('IN', $child_id)))->delete();
        	M('access')->where(array('node_id' => array('IN', $child_id)))->delete(); 
        	
        }
        
        $this->success('卸载成功', U('Index/index'));
    }

	
}



?>